<template>
  <div>
    <portal to="map">
      <MglConfig @click="click" />
    </portal>
    <div class="stuff">
      <client-only>
        <div v-if="clickLocation">
          <h3>Locations</h3>
          <pre>{{ clickLocation.lat.toFixed(4) }} N</pre>
          <pre>{{ clickLocation.lng.toFixed(4) }} E</pre>
        </div>
        <vue-json-pretty :data="features" />
      </client-only>
    </div>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";
.stuff {
  pointer-events: initial;
  max-width: 50%;
  background: $color-background;
  left: 0;
  max-height: 90vh;
  overflow-y: scroll;
  overflow-x: hidden;
}
</style>
<script>
import MglConfig from "~/components/mapping/MglConfig";
import MapReference from "~/mixins/MapReference";

export default {
  mixins: [MapReference],
  data() {
    return {
      clickLocation: null,
      features: null,
    };
  },
  components: {
    MglConfig,
    "vue-json-pretty": () =>
      import("vue-json-pretty").then((m) => m.default || m),
  },
  methods: {
    click(event) {
      console.log(event);
      this.clickLocation = { ...event.lngLat };
      this.features = this.map.map.queryRenderedFeatures(event.point);
    },
  },
};
</script>
